//  comm.h : CComm NX̐錾уC^[tFCX̒`܂B
//
// $Header: /aplinksw32/comm.h 1     96/05/11 21:18 Akagawa $
//
/////////////////////////////////////////////////////////////////////////////
#include <windows.h>

#ifndef DEF_CCOMM

#define DEF_CCOMM
#if !defined(comm_h)
static char *comm_h = "$Header: /aplinksw32/comm.h 1     96/05/11 21:18 Akagawa $";
#endif

//bps
#define BPS_300		CBR_300
#define BPS_600		CBR_600
#define BPS_1200	CBR_1200
#define BPS_2400	CBR_2400;
#define BPS_4800	CBR_4800;
#define BPS_9600	CBR_9600;
#define BPS_19200	CBR_19200;
#define BPS_38400	CBR_38400;


#define XFLOW_OFF		0x00	/* Disable X-Flow */
#define XFLOW_ON		0x01	/* Enable X-Flow */

// Flow control flags

#define FC_NONE         0x00
#define FC_DTRDSR       0x01
#define FC_RTSCTS       0x02
#define FC_RXONXOFF     0x04
#define FC_SXONXOFF     0x08

// ascii definitions

#define ASCII_BEL       0x07
#define ASCII_BS        0x08
#define ASCII_LF        0x0A
#define ASCII_CR        0x0D
#define ASCII_XON       0x11
#define ASCII_XOFF      0x13

#define RXQUEUE         4096
#define TXQUEUE         1

class CComm
{
public:
	CComm();
	~CComm();
	BOOL OpenConnection(BYTE bPort = 1, DWORD dwBaudRate = CBR_9600, BYTE bByteSize = 8, BYTE bStopBits = ONESTOPBIT, BYTE bParity = NOPARITY, BYTE bFlowCtrl = FC_NONE );
	BOOL SetupConnection(DWORD dwBaudRate, BYTE bByteSize = 255, BYTE bStopBits = 255, BYTE bParity = 255, BYTE bFlowCtrl = 255);
	BOOL CloseConnection();
	int  ReadCommByte();
	BOOL WriteCommByte( BYTE bByte );
	inline BOOL NEAR Connected( void ) { return m_fConnected; };
	DWORD NEAR GetBaud( int nBaud ) { 	return ((DWORD)1200 << (nBaud)); };
	BOOL WaitComm();
	void CrearMask(){SetCommMask( m_idComDev, 0 );} ;
	inline DWORD GetError() { return m_dwLastError; }; 
	BOOL WINAPI handler_routine(DWORD dwCtrlType);

private:
	HANDLE		m_idComDev ;
	BYTE		m_bPort;
	BYTE		m_bByteSize;
	BYTE		m_bFlowCtrl;
	BYTE		m_bParity;
	BYTE		m_bStopBits;
	DWORD		m_dwBaudRate;
//	HANDLE		hPostEvent, hWatchThread, hWatchEvent;
	BOOL		m_fConnected;
	OVERLAPPED	m_osWrite, m_osRead ;
	unsigned char *m_pbBuffer;
	DWORD		m_dwBufferInData;
	DWORD		m_dwLastError;

	BOOL NEAR ReadCommBlock();
};

#endif